import abc
from _typeshed import Incomplete
from abc import ABC, abstractmethod
from datasurface.md import Documentation as Documentation
from datasurface.md.Documentation import Documentable as Documentable
from enum import Enum
from typing import Generic, TypeVar

T = TypeVar('T')

class Policy(ABC, Documentable, Generic[T], metaclass=abc.ABCMeta):
    name: Incomplete
    def __init__(self, name: str, doc: Documentation | None = None) -> None: ...
    @abstractmethod
    def isCompatible(self, obj: T) -> bool: ...
    def __eq__(self, __value: object) -> bool: ...
    def __hash__(self) -> int: ...
P = TypeVar('P')

class AllowDisallowPolicy(Policy[P]):
    allowed: Incomplete
    notAllowed: Incomplete
    def __init__(self, name: str, doc: Documentation | None, allowed: set[P] | None = None, notAllowed: set[P] | None = None) -> None: ...
    def isCompatible(self, obj: P) -> bool: ...
    def __hash__(self) -> int: ...
    def __eq__(self, o: object) -> bool: ...

class DataClassification(ABC):
    def __init__(self) -> None: ...
    def __eq__(self, o: object) -> bool: ...

class SimpleDCTypes(Enum):
    PUB: int
    IP: int
    PC1: int
    PC2: int
    CPI: int
    MNPI: int
    CSI: int
    PC3: int

class SimpleDC(DataClassification):
    dcType: Incomplete
    name: Incomplete
    def __init__(self, dcType: SimpleDCTypes, name: str | None = None) -> None: ...
    def __hash__(self) -> int: ...
    def __eq__(self, o: object) -> bool: ...

class DataClassificationPolicy(AllowDisallowPolicy[DataClassification]):
    def __init__(self, name: str, doc: Documentation | None, allowed: set[DataClassification] | None = None, notAllowed: set[DataClassification] | None = None) -> None: ...
    def __eq__(self, v: object) -> bool: ...
    def __hash__(self) -> int: ...

class VerifyNoPrivacyDataVerify(DataClassificationPolicy):
    def __init__(self, doc: Documentation | None) -> None: ...
    def __hash__(self) -> int: ...
